// EMDataC.C - Steve Ludtke  11/27/2000
// More stuff for the bloated EMData object
// These routines are mainly for treating EMData objects as
// vectors and matrices. Inefficient, but functional.

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "List.h"
#include "mrc.h"
#include "imagic.h"
#include "emim.h"
#include "gatan.h"
#include "util.h"
#include "EMData.h"

// returns an EMData object containing all of the data at y=n
EMData *EMData::row(int n) {
EMData *ret = new EMData;
ret->setSize(xSize(),1,1);
memcpy(ret->getData(),getDataRO()+xSize()*n,xSize()*sizeof(float));
doneData();
ret->doneData();
return ret;
}

// returns an EMData object containing all of the data at x=n
EMData *EMData::col(int n) {
EMData *ret = new EMData;
ret->setSize(ySize(),1,1);
float *dst=ret->getData(),*src=getDataRO();
for (int i; i<ySize(); i++) dst[i]=src[i*xSize()+n];
ret->doneData();
doneData();
return ret;
}

void EMData::setRow(EMData *d,int n) {
float *dst=getData(),*src=d->getDataRO();

memcpy(dst+xSize()*n,src,xSize()*sizeof(float));
doneData();
d->doneData();
}

void EMData::setCol(EMData *d,int n) {
float *dst=getData(),*src=d->getDataRO();
for (int i; i<ySize(); i++) dst[i*xSize()+n]=src[i];
d->doneData();
doneData();
}


// UNIMPLEMENTED
// 2d matrix multiply  this * second
// Note both row and column vectors (if vector matrix mult) stored
// as nx>1 ny=1
EMData *EMData::mxMult(EMData *second) {
return NULL;
}

// Distance between 2 vectors, n specifies the row in 'second'
float EMData::dist(EMData *second,int n) {
if (second->xSize()!=xSize() || ySize()!=1) return -1.0;
float ret=0;
if (n>second->ySize()||n<0) return -1.0;
float *d1 = getDataRO(), *d2 = second->getDataRO() + second->xSize()*n;
for (int i=0; i<xSize(); i++) ret+=SQR(d1[i]-d2[i]);
return sqrt(ret);
}
