// ctfavg.C Copyright 1999 Steve Ludtke
// This program will average all the particles in a file together
// including CTF correction. No alignment is performed.

#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <math.h>
#include "List.h"

#include "EMData.h"

main(int argc, char** argv)
{
int i,j;
float filtr;
EMData av;
List *in;
XYData SF;
char *ctfcw=NULL;
int WienerCorrection=0;

if (argc<3 || argc>5) { 
	printf("Average the images in a file with CTF correction, but no alignment.\n");
	printf("ctfavg <infile><outfile> res=<res in A>  SFfile=<SF file> \n");
	exit(0); 
}

for (i=3; i<argc; i++) {	
	if (strncmp(argv[i],"res=",4)==0) filtr=atof(&argv[i][4]);
	else if  (strncmp(argv[i],"SFfile=",6)==0) {ctfcw=&argv[i][6] ; 
												WienerCorrection=1;}
	else { printf("Unknown argument '%s'\n",argv[i]); exit(1); }
}

if (WienerCorrection) {
	SF.readFile(ctfcw);	
	float *d=SF.getData();
	for (i=1; i<SF.n()*2; i+=2) d[i]=(d[i]<=0)?-4.0:log10(d[i]);
	SF.update();


	for (i=0; i<SF.n();i++) 
		if (i==0) printf("x=%f y=%f \n", SF.x(i),SF.y(i));
}

in=readImages(argv[1],-1,-1);


if (!((EMData *)in->objectAt(0))->hasCTF()) 
	{ printf("These images don't appear to have CTF parameters\n"); exit(1); }
	printf("Averaging %d images\n",in->count());
	filtr=atof(argv[3]);





if (WienerCorrection) {
		av.makeAverageCTFCW(in,&SF);
	} else {
		av.makeAverageCTFC(in,filtr);
	}
	
	av.writeIMAGIC(argv[2],-1);

}

