#include <stdio.h>
#include <math.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

main(int argc, char *argv[]) {
EMData d1,d2,*f1,*f2;
int n1=0,n2=0,nx,ny;
float *rd,*nrd,*nrd2;
float *dat,*dat2;
int i,j,k,x,y;
float r;

if (argc<3) { printf("usage:\nfsc2d <infile1> <infile2> [imnum1] [imnum2]\n"); exit(1); }
if (argc>=4) sscanf(argv[3]," %d",&n1);
if (argc>=5) sscanf(argv[4]," %d",&n2);

d1.readImage(argv[1],n1);
d2.readImage(argv[2],n2);

nx=d1.xSize();
ny=d1.ySize();

f1=d1.doFFT();
f2=d2.doFFT();

dat=f1->getDataRO();
dat2=f2->getDataRO();

rd=(float *)malloc(ny/2*sizeof(float));
nrd=(float *)malloc(ny/2*sizeof(float));
nrd2=(float *)malloc(ny/2*sizeof(float));

memset(rd,0,ny/2*sizeof(float));
memset(nrd,0,ny/2*sizeof(float));
memset(nrd2,0,ny/2*sizeof(float));

for (j=0,y=0; j<ny; j++) {
	for (i=0; i<nx; i+=2,y+=2) {
		r=sqrt(SQR(i/2)+SQR(j-ny/2));

		x=round(r);
		if (x<ny/2 && x>=0) { 
			rd[x]+=dat[y]*dat2[y]+dat[y+1]*dat2[y+1]; 
			nrd[x]+=dat[y]*dat[y]+dat[y+1]*dat[y+1]; 
			nrd2[x]+=dat2[y]*dat2[y]+dat2[y+1]*dat2[y+1];
		}
	}
}

FILE *out=fopen("fsc.dat","w");
if (!out) { printf("Cannot open output\n"); exit(1); }
for (i=0; i<ny/2; i++) if (nrd[i]>0) fprintf(out,"%d\t%f\n",i+1,rd[i]/(sqrt(nrd[i])*sqrt(nrd2[i])));
fclose(out);

}
